variables:
  ASSET_BLUEPRINT: blueprint.sh
  ASSET_BLUEPRINT_TAR: blueprint.tar.gz
  GIT_SUBMODULE_STRATEGY: recursive
  PACKAGE_REGISTRY_URL: "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_PROJECT_NAME}/${CI_COMMIT_TAG}"

stages:
  - build
  - upload
  - publish

build:
  stage: build
  image: registry.gitlab.com/silicon-hills/community/ci-images/node:0.0.1
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - make -s package
  artifacts:
    paths:
      - blueprint.tar.gz
      - blueprint.sh
    expire_in: 1 hour

upload:
  stage: upload
  image: curlimages/curl:latest
  rules:
    - if: $CI_COMMIT_TAG
  needs:
    - build
  script:
    - |
      curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file ${ASSET_BLUEPRINT} \
        ${PACKAGE_REGISTRY_URL}/${ASSET_BLUEPRINT}
      curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file ${ASSET_BLUEPRINT_TAR} \
        ${PACKAGE_REGISTRY_URL}/${ASSET_BLUEPRINT_TAR}

release:
  stage: publish
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  rules:
    - if: $CI_COMMIT_TAG
  needs:
    - upload
  script:
    - |
      release-cli create --name "Release $CI_COMMIT_TAG" --tag-name $CI_COMMIT_TAG \
        --assets-link "{\"name\":\"${ASSET_BLUEPRINT}\",\"url\":\"${PACKAGE_REGISTRY_URL}/${ASSET_BLUEPRINT}\"}" \
        --assets-link "{\"name\":\"${ASSET_BLUEPRINT_TAR}\",\"url\":\"${PACKAGE_REGISTRY_URL}/${ASSET_BLUEPRINT_TAR}\"}"
